=== examples/boulderdash/Makefile ===
OBJS=boulderdash.cmo
NAME=boulderdash
OPTIONS=-I ../../examples/boulderdash/ -file maps.txt:/ -file maps:/
include ../Makefile.common
