=== examples/graph_viewer/Makefile ===
OBJS=scene.cmo viewer_common.cmo viewer_js.cmo
NAME=jsviewer
OPTIONS=-I ../../examples/graph_viewer -file scene.json:/

include ../Makefile.common
include .depend
