=== examples/hyperbolic/Makefile ===
OBJS=hypertree.cmo
NAME=hypertree
OPTIONS=-I ../../examples/hyperbolic -file image_info.json:/ -file messages.json:/ -file tree.json:/

include ../Makefile.common
