=== examples/webgl/Makefile ===
OBJS=webgldemo.cmo
NAME=webgldemo
OPTIONS=-I ../../examples/webgl -file monkey.model:/

include ../Makefile.common
