=== debian/changelog ===
js-of-ocaml (2.2-2) unstable; urgency=medium

  * Fix FTBFS on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Wed, 18 Jun 2014 12:59:58 +0200

js-of-ocaml (2.2-1) unstable; urgency=medium

  * New upstream release (Closes: #751693)
  * debian/patches:
    + Fix generation of compiler.cm*

 -- Stéphane Glondu <glondu@debian.org>  Tue, 17 Jun 2014 11:45:02 +0200
