=== debian/control ===
Source: js-of-ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 dh-ocaml (>= 0.9~),
 ocaml-findlib (>= 1.4),
 liblwt-ocaml-dev (>= 2.4),
 libderiving-ocsigen-ocaml-dev (>= 0.6),
 camlp4,
 menhir,
 ocaml-nox (>= 4.01)
Standards-Version: 3.9.5
Homepage: http://ocsigen.org/js_of_ocaml
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/js-of-ocaml.git

Package: js-of-ocaml
Architecture: any
Depends:
 libjs-of-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (compiler)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains the compiler itself.

Package: libjs-of-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libjs-of-ocaml (<< 1.4)
Replaces: libjs-of-ocaml (<< 1.4)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (development files)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains development files needed to compile server-side
 (using regular OCaml compiler) and client-side (using Js_of_ocaml)
 programs.

Package: libjs-of-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libjs-of-ocaml-dev (<< 1.4)
Replaces: libjs-of-ocaml-dev (<< 1.4)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (runtime)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains runtime libraries that may be needed by
 server-side programs communicating with clients compiled with
 Js_of_ocaml using JSON.

Package: libjs-of-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: OCaml bytecode to JavaScript compiler (documentation)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser.
 .
 This package contains the API reference and examples.
